﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace OtborEtap.Models;

public partial class PrdbOtborContext : DbContext
{
    public PrdbOtborContext()
    {
    }

    public PrdbOtborContext(DbContextOptions<PrdbOtborContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Auth> Auths { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Threat> Threats { get; set; }

    public virtual DbSet<User> Users { get; set; }

    public virtual DbSet<UsersThreat> UsersThreats { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see http://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=prdb_otbor;Username=prdb_otbor;Password=prdb_otbor");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Auth>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("auth_pk");

            entity.ToTable("auth");

            entity.HasIndex(e => e.Login, "auth_un").IsUnique();

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Login)
                .HasColumnType("character varying")
                .HasColumnName("login");
            entity.Property(e => e.Password)
                .HasColumnType("character varying")
                .HasColumnName("password");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("genders_pk");

            entity.ToTable("genders");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Gender1)
                .HasColumnType("character varying")
                .HasColumnName("gender");
        });

        modelBuilder.Entity<Threat>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("threats_pk");

            entity.ToTable("threats");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Threat1)
                .HasColumnType("character varying")
                .HasColumnName("threat");
        });

        modelBuilder.Entity<User>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("users_pk");

            entity.ToTable("users");

            entity.Property(e => e.Id)
                .ValueGeneratedNever()
                .HasColumnName("id");
            entity.Property(e => e.BirthDate).HasColumnName("birth_date");
            entity.Property(e => e.IdGender).HasColumnName("id_gender");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");

            entity.HasOne(d => d.IdNavigation).WithOne(p => p.User)
                .HasForeignKey<User>(d => d.Id)
                .HasConstraintName("users_fk");

            entity.HasOne(d => d.IdGenderNavigation).WithMany(p => p.Users)
                .HasForeignKey(d => d.IdGender)
                .OnDelete(DeleteBehavior.Restrict)
                .HasConstraintName("users_fk_1");
        });

        modelBuilder.Entity<UsersThreat>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("ut_pk");

            entity.ToTable("users_threats");

            entity.HasIndex(e => new { e.IdUser, e.IdThreat }, "users_threats_un").IsUnique();

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.IdThreat).HasColumnName("id_threat");
            entity.Property(e => e.IdUser).HasColumnName("id_user");

            entity.HasOne(d => d.IdThreatNavigation).WithMany(p => p.UsersThreats)
                .HasForeignKey(d => d.IdThreat)
                .HasConstraintName("threats_fk");

            entity.HasOne(d => d.IdUserNavigation).WithMany(p => p.UsersThreats)
                .HasForeignKey(d => d.IdUser)
                .HasConstraintName("users_fk");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
