﻿using Avalonia.Controls;
using OtborEtap.Models;
using OtborEtap.Views;
using ReactiveUI;
using System.Linq;
using System.Runtime.CompilerServices;
using System;

namespace OtborEtap.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        PrdbOtborContext db = new PrdbOtborContext();

        string text;
        string login;
        string password;
        string info;
        UserControl uc;

        Auth auth = new Auth();
        User users = new User();

        //public static MainWindowViewModel Self;

        public MainWindowViewModel()    
        {
            //Self = this;

            Uc = new AuthForUser();
        }

        public UserControl Uc { get => uc; set => this.RaiseAndSetIfChanged(ref uc, value); }

        public string Login { get => login; set => this.RaiseAndSetIfChanged(ref login, value); }

        public string Password { get => password; set => this.RaiseAndSetIfChanged(ref password, value); }

        public string Info { get => info; set => this.RaiseAndSetIfChanged(ref info, value); }

        public void Enter()
        {
            auth = db.Auths.FirstOrDefault(x => x.Login == login && x.Password == password);
            if (auth != null)
            {
                Uc = new UserPageForInfo();
            }   
            else
            {
                info = "Неверный логин или пароль";
                password = "";
            }
        }
    }
}
